zoukankan      html  css  js  c++  java
  • HDU 1087 Super Jumping! Jumping! Jumping!

    题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1087

    Super Jumping! Jumping! Jumping!

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
    Total Submission(s): 29371    Accepted Submission(s): 13118


    Problem Description
    Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



    The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
    Your task is to output the maximum value according to the given chessmen list.
     
    Input
    Input contains multiple test cases. Each test case is described in a line as follow:
    N value_1 value_2 …value_N
    It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
    A test case starting with 0 terminates the input and this test case is not to be processed.
     
    Output
    For each case, print the maximum according to rules, and one line one case.
     
    Sample Input
    3 1 3 2 4 1 2 3 4 4 3 3 2 1 0
     
    Sample Output
    4 10 3
     
    Author
    lcy
    题意 : 从起点到终点,每次只能跳到比上一次大的点,问跳过的格子上和最大是多少。
    分析:简单dp。
     
    #include <iostream>
    #include <cstdio>
    #include <cstring>
    #include <cstdlib>
    #include <algorithm>
    
    using namespace std;
    
    int dp[1005];
    int a[1005];
    
    int main()
    {
        int n;
        while(scanf("%d", &n),n)
        {
            for(int i=1; i<=n; i++)
            {
                scanf("%d",&a[i]);
            }
            dp[1] = a[1];
            int Max = dp[1];
            for(int i=1; i<=n; i++)
            {
                dp[i] = a[i];
                for(int j=1;j<i;j++)
                {
                    if(a[i]>a[j])
                    {
                        dp[i] = max(dp[i], dp[j]+a[i]);
                    }
                    if(dp[i]>Max)
                        Max = dp[i];
                }
            }
            printf("%d
    ",Max);
    
    
        }
    
        return 0;
    }
  • 相关阅读:
    java算法:构建块
    和菜鸟一起学linux总线驱动之初识smartcard操作过程
    java算法:算法分析事例
    java算法:数组
    网上交易 Q币冲击人民币?
    一段搞笑代码,让网页上所有图片飞起来转圈
    黑客系列教程之暴力注入Explorer
    一段搞笑代码,让网页上所有图片飞起来转圈
    巧妙破解开别人ASP木马密码的方法
    巧妙破解开别人ASP木马密码的方法
  • 原文地址:https://www.cnblogs.com/mengzhong/p/5039000.html
Copyright © 2011-2022 走看看